|
|
7711c0 |
From ef0a9b41515ff3392afdaeeb37bd32568ba8ffe4 Mon Sep 17 00:00:00 2001
|
|
|
7711c0 |
From: John Snow <jsnow@redhat.com>
|
|
|
7711c0 |
Date: Fri, 22 Mar 2019 03:22:32 +0100
|
|
|
7711c0 |
Subject: [PATCH 065/163] tests: pull qemu-nbd iotest helpers into common.nbd
|
|
|
7711c0 |
file
|
|
|
7711c0 |
MIME-Version: 1.0
|
|
|
7711c0 |
Content-Type: text/plain; charset=UTF-8
|
|
|
7711c0 |
Content-Transfer-Encoding: 8bit
|
|
|
7711c0 |
|
|
|
7711c0 |
RH-Author: John Snow <jsnow@redhat.com>
|
|
|
7711c0 |
Message-id: <20190322032241.8111-20-jsnow@redhat.com>
|
|
|
7711c0 |
Patchwork-id: 85108
|
|
|
7711c0 |
O-Subject: [RHEL-7.7 qemu-kvm-rhev PATCH 19/28] tests: pull qemu-nbd iotest helpers into common.nbd file
|
|
|
7711c0 |
Bugzilla: 1691563
|
|
|
7711c0 |
RH-Acked-by: Max Reitz <mreitz@redhat.com>
|
|
|
7711c0 |
RH-Acked-by: Stefan Hajnoczi <stefanha@redhat.com>
|
|
|
7711c0 |
RH-Acked-by: Miroslav Rezanina <mrezanin@redhat.com>
|
|
|
7711c0 |
|
|
|
7711c0 |
From: Daniel P. Berrangé <berrange@redhat.com>
|
|
|
7711c0 |
|
|
|
7711c0 |
The helpers for starting/stopping qemu-nbd in 058 will be useful in
|
|
|
7711c0 |
other test cases, so move them into a common.nbd file.
|
|
|
7711c0 |
|
|
|
7711c0 |
Signed-off-by: Daniel P. Berrangé <berrange@redhat.com>
|
|
|
7711c0 |
Message-Id: <20181116155325.22428-4-berrange@redhat.com>
|
|
|
7711c0 |
Reviewed-by: Eric Blake <eblake@redhat.com>
|
|
|
7711c0 |
[eblake: fix shell quoting]
|
|
|
7711c0 |
Signed-off-by: Eric Blake <eblake@redhat.com>
|
|
|
7711c0 |
(cherry picked from commit e6d5d6fdd43484f60f678e66c21f0d1286749977)
|
|
|
7711c0 |
Signed-off-by: John Snow <jsnow@redhat.com>
|
|
|
7711c0 |
|
|
|
7711c0 |
Signed-off-by: Miroslav Rezanina <mrezanin@redhat.com>
|
|
|
7711c0 |
---
|
|
|
7711c0 |
tests/qemu-iotests/058 | 47 +++++++-----------------------------
|
|
|
7711c0 |
tests/qemu-iotests/common.nbd | 56 +++++++++++++++++++++++++++++++++++++++++++
|
|
|
7711c0 |
2 files changed, 64 insertions(+), 39 deletions(-)
|
|
|
7711c0 |
create mode 100644 tests/qemu-iotests/common.nbd
|
|
|
7711c0 |
|
|
|
7711c0 |
diff --git a/tests/qemu-iotests/058 b/tests/qemu-iotests/058
|
|
|
7711c0 |
index 0d741a7..d6d4f94 100755
|
|
|
7711c0 |
--- a/tests/qemu-iotests/058
|
|
|
7711c0 |
+++ b/tests/qemu-iotests/058
|
|
|
7711c0 |
@@ -28,55 +28,19 @@ echo "QA output created by $seq"
|
|
|
7711c0 |
|
|
|
7711c0 |
status=1 # failure is the default!
|
|
|
7711c0 |
|
|
|
7711c0 |
-nbd_unix_socket=$TEST_DIR/test_qemu_nbd_socket
|
|
|
7711c0 |
-nbd_snapshot_img="nbd:unix:$nbd_unix_socket"
|
|
|
7711c0 |
-rm -f "${TEST_DIR}/qemu-nbd.pid"
|
|
|
7711c0 |
-
|
|
|
7711c0 |
-_cleanup_nbd()
|
|
|
7711c0 |
-{
|
|
|
7711c0 |
- local NBD_SNAPSHOT_PID
|
|
|
7711c0 |
- if [ -f "${TEST_DIR}/qemu-nbd.pid" ]; then
|
|
|
7711c0 |
- read NBD_SNAPSHOT_PID < "${TEST_DIR}/qemu-nbd.pid"
|
|
|
7711c0 |
- rm -f "${TEST_DIR}/qemu-nbd.pid"
|
|
|
7711c0 |
- if [ -n "$NBD_SNAPSHOT_PID" ]; then
|
|
|
7711c0 |
- kill "$NBD_SNAPSHOT_PID"
|
|
|
7711c0 |
- fi
|
|
|
7711c0 |
- fi
|
|
|
7711c0 |
- rm -f "$nbd_unix_socket"
|
|
|
7711c0 |
-}
|
|
|
7711c0 |
-
|
|
|
7711c0 |
-_wait_for_nbd()
|
|
|
7711c0 |
-{
|
|
|
7711c0 |
- for ((i = 0; i < 300; i++))
|
|
|
7711c0 |
- do
|
|
|
7711c0 |
- if [ -r "$nbd_unix_socket" ]; then
|
|
|
7711c0 |
- return
|
|
|
7711c0 |
- fi
|
|
|
7711c0 |
- sleep 0.1
|
|
|
7711c0 |
- done
|
|
|
7711c0 |
- echo "Failed in check of unix socket created by qemu-nbd"
|
|
|
7711c0 |
- exit 1
|
|
|
7711c0 |
-}
|
|
|
7711c0 |
-
|
|
|
7711c0 |
-converted_image=$TEST_IMG.converted
|
|
|
7711c0 |
-
|
|
|
7711c0 |
_export_nbd_snapshot()
|
|
|
7711c0 |
{
|
|
|
7711c0 |
- _cleanup_nbd
|
|
|
7711c0 |
- $QEMU_NBD -v -t -k "$nbd_unix_socket" "$TEST_IMG" -l $1 &
|
|
|
7711c0 |
- _wait_for_nbd
|
|
|
7711c0 |
+ nbd_server_start_unix_socket "$TEST_IMG" -l $1
|
|
|
7711c0 |
}
|
|
|
7711c0 |
|
|
|
7711c0 |
_export_nbd_snapshot1()
|
|
|
7711c0 |
{
|
|
|
7711c0 |
- _cleanup_nbd
|
|
|
7711c0 |
- $QEMU_NBD -v -t -k "$nbd_unix_socket" "$TEST_IMG" -l snapshot.name=$1 &
|
|
|
7711c0 |
- _wait_for_nbd
|
|
|
7711c0 |
+ nbd_server_start_unix_socket "$TEST_IMG" -l snapshot.name=$1
|
|
|
7711c0 |
}
|
|
|
7711c0 |
|
|
|
7711c0 |
_cleanup()
|
|
|
7711c0 |
{
|
|
|
7711c0 |
- _cleanup_nbd
|
|
|
7711c0 |
+ nbd_server_stop
|
|
|
7711c0 |
_cleanup_test_img
|
|
|
7711c0 |
rm -f "$converted_image"
|
|
|
7711c0 |
}
|
|
|
7711c0 |
@@ -86,6 +50,7 @@ trap "_cleanup; exit \$status" 0 1 2 3 15
|
|
|
7711c0 |
. ./common.rc
|
|
|
7711c0 |
. ./common.filter
|
|
|
7711c0 |
. ./common.pattern
|
|
|
7711c0 |
+. ./common.nbd
|
|
|
7711c0 |
|
|
|
7711c0 |
_supported_fmt qcow2
|
|
|
7711c0 |
_supported_proto file
|
|
|
7711c0 |
@@ -94,6 +59,10 @@ _require_command QEMU_NBD
|
|
|
7711c0 |
# Internal snapshots are (currently) impossible with refcount_bits=1
|
|
|
7711c0 |
_unsupported_imgopts 'refcount_bits=1[^0-9]'
|
|
|
7711c0 |
|
|
|
7711c0 |
+nbd_snapshot_img="nbd:unix:$nbd_unix_socket"
|
|
|
7711c0 |
+
|
|
|
7711c0 |
+converted_image=$TEST_IMG.converted
|
|
|
7711c0 |
+
|
|
|
7711c0 |
# Use -f raw instead of -f $IMGFMT for the NBD connection
|
|
|
7711c0 |
QEMU_IO_NBD="$QEMU_IO -f raw --cache=$CACHEMODE"
|
|
|
7711c0 |
|
|
|
7711c0 |
diff --git a/tests/qemu-iotests/common.nbd b/tests/qemu-iotests/common.nbd
|
|
|
7711c0 |
new file mode 100644
|
|
|
7711c0 |
index 0000000..27357f3
|
|
|
7711c0 |
--- /dev/null
|
|
|
7711c0 |
+++ b/tests/qemu-iotests/common.nbd
|
|
|
7711c0 |
@@ -0,0 +1,56 @@
|
|
|
7711c0 |
+#!/bin/bash
|
|
|
7711c0 |
+# -*- shell-script-mode -*-
|
|
|
7711c0 |
+#
|
|
|
7711c0 |
+# Helpers for NBD server related config
|
|
|
7711c0 |
+#
|
|
|
7711c0 |
+# Copyright (C) 2018 Red Hat, Inc.
|
|
|
7711c0 |
+#
|
|
|
7711c0 |
+# This program is free software; you can redistribute it and/or modify
|
|
|
7711c0 |
+# it under the terms of the GNU General Public License as published by
|
|
|
7711c0 |
+# the Free Software Foundation; either version 2 of the License, or
|
|
|
7711c0 |
+# (at your option) any later version.
|
|
|
7711c0 |
+#
|
|
|
7711c0 |
+# This program is distributed in the hope that it will be useful,
|
|
|
7711c0 |
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
|
|
|
7711c0 |
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
|
|
|
7711c0 |
+# GNU General Public License for more details.
|
|
|
7711c0 |
+#
|
|
|
7711c0 |
+# You should have received a copy of the GNU General Public License
|
|
|
7711c0 |
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
|
|
|
7711c0 |
+#
|
|
|
7711c0 |
+
|
|
|
7711c0 |
+nbd_unix_socket="${TEST_DIR}/qemu-nbd.sock"
|
|
|
7711c0 |
+nbd_pid_file="${TEST_DIR}/qemu-nbd.pid"
|
|
|
7711c0 |
+
|
|
|
7711c0 |
+function nbd_server_stop()
|
|
|
7711c0 |
+{
|
|
|
7711c0 |
+ local NBD_PID
|
|
|
7711c0 |
+ if [ -f "$nbd_pid_file" ]; then
|
|
|
7711c0 |
+ read NBD_PID < "$nbd_pid_file"
|
|
|
7711c0 |
+ rm -f "$nbd_pid_file"
|
|
|
7711c0 |
+ if [ -n "$NBD_PID" ]; then
|
|
|
7711c0 |
+ kill "$NBD_PID"
|
|
|
7711c0 |
+ fi
|
|
|
7711c0 |
+ fi
|
|
|
7711c0 |
+ rm -f "$nbd_unix_socket"
|
|
|
7711c0 |
+}
|
|
|
7711c0 |
+
|
|
|
7711c0 |
+function nbd_server_wait_for_unix_socket()
|
|
|
7711c0 |
+{
|
|
|
7711c0 |
+ for ((i = 0; i < 300; i++))
|
|
|
7711c0 |
+ do
|
|
|
7711c0 |
+ if [ -r "$nbd_unix_socket" ]; then
|
|
|
7711c0 |
+ return
|
|
|
7711c0 |
+ fi
|
|
|
7711c0 |
+ sleep 0.1
|
|
|
7711c0 |
+ done
|
|
|
7711c0 |
+ echo "Failed in check of unix socket created by qemu-nbd"
|
|
|
7711c0 |
+ exit 1
|
|
|
7711c0 |
+}
|
|
|
7711c0 |
+
|
|
|
7711c0 |
+function nbd_server_start_unix_socket()
|
|
|
7711c0 |
+{
|
|
|
7711c0 |
+ nbd_server_stop
|
|
|
7711c0 |
+ $QEMU_NBD -v -t -k "$nbd_unix_socket" "$@" &
|
|
|
7711c0 |
+ nbd_server_wait_for_unix_socket
|
|
|
7711c0 |
+}
|
|
|
7711c0 |
--
|
|
|
7711c0 |
1.8.3.1
|
|
|
7711c0 |
|